<?php

namespace FiloBlu\Flow\Console\Command;

use FiloBlu\Flow\Cron\FetchFactory;
use Magento\Framework\App\State;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Class CriticalCommand
 * @package FiloBlu\Flow\Console\Command
 */
class CycleCommand extends BaseCommand
{
    public function __construct(State $state, FetchFactory $fetchFactory, $name = null)
    {
        parent::__construct($state, $fetchFactory, $name);
    }

    /**
     *
     */
    protected function configure()
    {
        $this->setName('flow:cycle')
            ->setDescription('Execute fetch, receive, parse and process at once');
    }

    /**
     * @param InputInterface $input
     * @param OutputInterface $output
     * @throws \Exception
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $this->ensureAreaCode($output);

        $cronModel = $this->fetchFactory->create();
        $cronModel->executeBus1();
        $cronModel->executeBus2();
        $cronModel->executeBus3();
        $cronModel->executeBus4();
        $cronModel->receive();
        $cronModel->parse();
        $cronModel->process();
        $output->writeln('<info>Processed criticals !</info>');
    }
}